#include <iostream>
#include <cstdlib>
using namespace std;

int main()
{
    int T;
    cin>>T;
    int x[T]={1};
    long long int govno,koe=1000000000000000000,N,M;
    for(int i=0;i<T;i++)
    {
        cin>>M>>N;
        long long int M1[M],N1[N];
        cin>>N1[0];

            for(long long int j=2;j<koe;j++)
            {
              govno=N1[0]%j;
        for (long long int y=1;y<N;y++)
        {
            cin>>N1[y];
            if(N1[y]%j!=govno)
            {
                x[T]=0;
            }
        }
        for (long long int h=0;h<M;h++)
        {
            cin>>M1[h];
            if (M1[h]%j==govno)
            {
                x[T]=0;
            }
        }
            }

    }
    for(int i=0;i<T;i++)
    {
    cout<<x[i];
    }
    return 0;
}